-- Copyright (c) 2005-2007, Douglas Stebila.

-- Redistribution and use in source and binary forms, with or without modification, are permitted 
-- provided that the following conditions are met:

-- 1. Redistributions of source code must retain the above copyright notice, this list of conditions and 
-- the following disclaimer.
-- 2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and 
-- the following disclaimer in the documentation and/or other materials provided with the distribution.
-- 3. The name of the author may not be used to endorse or promote products derived from this software 
-- without specific prior written permission.

-- THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
-- INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
-- FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR 
-- ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
-- (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
-- USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
-- LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
-- OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
-- POSSIBILITY OF SUCH DAMAGE.


-- iCalCopy.applescript
-- iCalCopy

on launched theObject
	
	set calendarNames to {}
	tell application "iCal"
		repeat with i in every calendar
			set the end of calendarNames to the name of i
		end repeat
	end tell
	
	set selectedSource to choose from list calendarNames with prompt "Please select the calendar from which events should be copied."
	if selectedSource is not false then
		
		set selectedSource to the first item of selectedSource
		set newCalendarNames to {}
		repeat with i from 1 to count of calendarNames
			set t to item i of calendarNames
			if t is not equal to selectedSource then set the end of newCalendarNames to t
		end repeat
		set selectedDestination to choose from list newCalendarNames with prompt "Please select the calendar to which events should be copied."
		if selectedDestination is not false then
			set selectedDestination to the first item of selectedDestination
			
			if selectedSource is not selectedDestination then
				
				-- Copy events
				tell application "iCal"
					set source to first item of (every calendar whose name is selectedSource)
					set destination to first item of (every calendar whose name is selectedDestination)
					set e to every event of source
				end tell
				set visible of window "Progress Window" to true
				set c to count of e
				set contents of text field "label" of window "Progress Window" to "Copying " & "1" & " of " & c & " events from " & selectedSource & " to " & selectedDestination & "..."
				set maximum value of progress indicator "bar" of window "Progress Window" to c
				set minimum value of progress indicator "bar" of window "Progress Window" to 0
				set indeterminate of progress indicator "bar" of window "Progress Window" to false
				repeat with i from 1 to c
					set contents of text field "label" of window "Progress Window" to "Copying " & i & " of " & c & " events from " & selectedSource & " to " & selectedDestination & "..."
					tell application "iCal"
						duplicate (item i of e) to the end of (destination's events)
					end tell
					set content of progress indicator "bar" of window "Progress Window" to i
					update window "Progress Window"
				end repeat
				
				-- Copy todos
				tell application "iCal"
					set e to every todo of source
				end tell
				set visible of window "Progress Window" to true
				set c to count of e
				set contents of text field "label" of window "Progress Window" to "Copying " & "1" & " of " & c & " To Do items from " & selectedSource & " to " & selectedDestination & "..."
				set maximum value of progress indicator "bar" of window "Progress Window" to c
				set minimum value of progress indicator "bar" of window "Progress Window" to 0
				set indeterminate of progress indicator "bar" of window "Progress Window" to false
				repeat with i from 1 to c
					set contents of text field "label" of window "Progress Window" to "Copying " & i & " of " & c & " To Do items from " & selectedSource & " to " & selectedDestination & "..."
					tell application "iCal"
						duplicate (item i of e) to the end of (destination's todos)
					end tell
					set content of progress indicator "bar" of window "Progress Window" to i
					update window "Progress Window"
				end repeat
				
				set contents of text field "label" of window "Progress Window" to "Done!"
			end if
			
		end if
		
	end if
	
	quit
	
end launched